function swfUploadPreLoad() {

  var self = this;
  var loading = function () {
    $("#" + this.customSettings.divLoading).css("display", "");		

    var longLoad = function () {
      addError(Drupal.t('Flash upload is taking a long time to load or the load has failed.  Please make sure that the Flash Plugin is enabled and that a working version of the Adobe Flash Player is installed.'));
    };

    this.customSettings.loadingTimeout = setTimeout(function () {
      longLoad.call(self)
    }, 15 * 1000 );
  };
	
  this.customSettings.loadingTimeout = setTimeout(function () {
      loading.call(self);
    }, 1*1000
  );
}

function swfUploadLoaded() {
  var S = this.customSettings;
  clearTimeout(S.loadingTimeout);
}

function swfUploadLoadFailed() { 
  var S = this.customSettings;
  clearTimeout(S.loadingTimeout);

  addError(Drupal.t('Flash upload could not load.  You may need to install or upgrade Flash Player. ' +
					'Visit the <a href="http://www.adobe.com/shockwave/download/download.cgi?P1_Prod _Version=ShockwaveFlash">Adobe website</a> to get the Flash Player.'));
}

function fileQueueError(file, errorCode, message) {
  try {
    var errorName = "";
    switch (errorCode) {
      case SWFUpload.errorCode_QUEUE_LIMIT_EXCEEDED:
        errorName = Drupal.t("You have attempted to queue too many files.");
      case SWFUpload.QUEUE_ERROR.ZERO_BYTE_FILE:
        errorName = Drupal.t("%file has zero bytes, cancel upload", { "%file" : file.name });
        break;
      case SWFUpload.QUEUE_ERROR.FILE_EXCEEDS_SIZE_LIMIT:
        errorName = Drupal.t("%file is too big", { "%file" : file });
        break;
      case SWFUpload.QUEUE_ERROR.INVALID_FILETYPE:
		errorName = Drupal.t("Filetype of %file is not allowed", { "@file" : file.name });
		break;
      default:
        errorName = Drupal.t("Unknown error @errorCode on %file: @message", { "@message" : message, "@errorCode" : errorCode, "%file" : file.name });
        break;
    }
    addError(errorName);
  } catch (ex) {
    this.debug(ex);
  }
}
function fileQueued(file) {
	try {
		var progress = new FileProgress(file, this.customSettings.upload_target);
		progress.setStatus(Drupal.t("Pending..."));
		progress.toggleCancel(true, this);

	} catch (ex) {
		this.debug(ex);
	}

}

function fileDialogComplete(numFilesSelected, numFilesQueued) {
  //try {
    var S = this.customSettings;
    
    if (numFilesSelected > 0 && !S.uploading) {
      S.numberOfSuccUploads = 0;
      
      var pid = $("select[@name='pid'] option[@selected]").val();
      if (pid && S.albumpid != pid) {
        S.albumpid = $("select[@name='pid'] option[@selected]").val();
        S.albumname = $("select[@name='pid'] option[@selected]").text();
      }

      this.setUploadURL(this.settings.upload_url + "&pid=" + S.albumpid);

      var text;
      if (typeof(S.albumname) != "undefined") {
        text = Drupal.t("Preview of newly uploaded photos to album %album", { '%album': S.albumname });
      } else {
        text = Drupal.t("Preview of newly uploaded photos");
      }

      $("#album-swfu-queue-fieldset").after('<fieldset class="album-swfu-preview collapsible"><legend>' + text + "</legend></fieldset>");
      
      $("#album-swfu-queue-fieldset").removeClass("collapsed");
      Drupal.behaviors.collapse();

      /* I want auto start the upload and I can do that here */
      S.uploading = true;
      this.startUpload();
    }	
  //} catch (ex)  {
  //  this.debug(ex);
  //}
}

// This event comes from the Queue Plugin
function queueComplete(numFilesUploaded) {
  var S = this.customSettings;

  $("button[@name='cancel-upload]").attr("disabled", "disabled");
  $("#" + S.files_target).text(Drupal.formatPlural(parseInt(numFilesUploaded), '1 file uploaded', '@count files uploaded'));
  S.uploading = false;

  if (S.numberOfSuccUploads == 0) {
    $(".album-swfu-preview:first").remove();
    return;
   }

   if (S.albumpid > 0) {
     var url =  S.organize_url.replace(/pid/, S.albumpid);
     var text = Drupal.t("Upload finished. Click here to organize the newly uploaded photos.");
     $(".album-swfu-preview:first").append('<p><a href="' + url + '">' + text + '</a></p>');
   }
}

function uploadProgress(file, bytesLoaded) {
  try {
    var percent = Math.ceil((bytesLoaded / file.size) * 100);

    var progress = new FileProgress(file,  this.customSettings.upload_target);
    progress.setProgress(percent);
    if (percent === 100) {
      progress.setStatus(Drupal.t("Creating thumbnail..."));
      progress.toggleCancel(false, this);
    }
    else {
      progress.setStatus(Drupal.t("Uploading..."));
      progress.toggleCancel(true, this);
    }
  } catch (ex) {
    this.debug(ex);
  }
}

function uploadSuccess(file, serverData) {
  try {
    var progress = new FileProgress(file,  this.customSettings.upload_target);
    var S = this.customSettings;

    if (serverData.substring(0, 7) === "FILEID:") {
      addImage(serverData);
      progress.setStatus(Drupal.t("Thumbnail Created"));
      progress.setComplete();
      progress.toggleCancel(false);

      S.numberOfSuccUploads += 1;
    }
    else {
      addError(Drupal.t("Upload of %file failed, !message", {"%file" : file.name, "!message" : serverData}));
      progress.setStatus(Drupal.t("Error"));
      progress.setError();
      progress.toggleCancel(false);
    }
  } catch (ex) {
    this.debug(ex);
  }
}

function uploadComplete(file) {
  try {
    var S = this.customSettings;
  
    /*  I want the next upload to continue automatically so I'll call startUpload here */
    if (this.getStats().files_queued > 0) {
      this.startUpload();
    }
  } catch (ex) {
    this.debug(ex);
  }
}

function addError(message) {
  if ($("#album-swfu-errors-fieldset").length == 0) {
	$("#album-swfu-queue-fieldset").before('<fieldset id="album-swfu-errors-fieldset"><legend>' + Drupal.t("Errors...") + '</legend><div  class="messages error"><ul></ul></div></fieldset>');
  }

  $("#album-swfu-errors-fieldset ul").append("<li>" + message + "</li>");
}

function uploadError(file, errorCode, message) {
  try {
    var errorName = "";
    var imageText = Drupal.t("Failed");
    var progress = new FileProgress(file,  this.customSettings.upload_target);
    
    switch (errorCode) {
      case SWFUpload.UPLOAD_ERROR.FILE_CANCELLED:
        errorName = Drupal.t("Upload of %file has been canceled", { "%file" : file.name });
        imageText = Drupal.t("Cancelled");
        progress.setCancelled();
		break;
        
      case SWFUpload.UPLOAD_ERROR.UPLOAD_STOPPED:
        errorName = Drupal.t("Upload of %file has been stopped", { "%file" : file.name });
        imageText = Drupal.t("Stopped");
        progress.setCancelled();
        break;

      default:
        var errorMsg = "";
        switch (parseInt(message)) {
          case 571:
            errorMsg = Drupal.t("No permissions to update node %node", { "%node" : this.customSettings.albumname });
            break;
          case 572:
            errorMsg = Drupal.t("No album found");
            break;
          case 573:
            errorMsg = Drupal.t("Zip-Upload is not allowed");
            break;
          case 574:
          case 575:
          case 576:
            errorMsg = Drupal.t('Internal system error, please contact the site administrator.');
            break;
          case 577:
            errorMsg = Drupal.t('File was rejected, re-check file type, size and resolution.');
            break;
          case 581:
            errorMsg = Drupal.t('Uploading was denied, because it exceeds the maximum allowed size for uploads.');
            break;
          case 582:
            errorMsg = Drupal.t('Uploading was canceled.');
            break;
          case 579:
            errorMsg = Drupal.t('Authentication failed, please contact the site administrator.');
            break;
        }

        errorName = Drupal.t("Error on %file: !errormsg", { "!errormsg" : errorMsg, "%file" : file.name });
        break;
    }
    
    progress.setStatus(imageText);
    progress.toggleCancel(true);
    
    addError(errorName);
  } catch (ex) {
    this.debug(ex);
  }
}

function addImage(src) {
   src = src.substr(7);
   var link = src.substr(0, src.indexOf(':'));
   var image = src.substr(src.indexOf(':') + 1);

   $(".album-swfu-preview:first").append('<a><img style="margin:5px;display:hidden"></a>');
   $(".album-swfu-preview:first img:last").fadeIn("slow").attr("src", image);
   $(".album-swfu-preview:first a:last").attr("href", link);

}

function fadeIn(element, opacity) {
	var reduceOpacityBy = 5;
	var rate = 30;	// 15 fps

	if (opacity < 100) {
		opacity += reduceOpacityBy;
		if (opacity > 100) {
			opacity = 100;
		}

		if (element.filters) {
			try {
				element.filters.item("DXImageTransform.Microsoft.Alpha").opacity = opacity;
			} catch (e) {
				// If it is not set initially, the browser will throw an error.  This will set it if it is not set yet.
				element.style.filter = 'progid:DXImageTransform.Microsoft.Alpha(opacity=' + opacity + ')';
			}
		} else {
			element.style.opacity = opacity / 100;
		}
	}

	if (opacity < 100) {
		setTimeout(function () {
			fadeIn(element, opacity);
		}, rate);
	}
}



/*
	A simple class for displaying file information and progress
	Note: This is a demonstration only and not part of SWFUpload.
	Note: Some have had problems adapting this class in IE7. It may not be suitable for your application.
*/

// Constructor
// file is a SWFUpload file object
// targetID is the HTML element id attribute that the FileProgress HTML structure will be added to.
// Instantiating a new FileProgress object with an existing file will reuse/update the existing DOM elements
function FileProgress(file, targetID) {
	this.fileProgressID = file.id;

	this.opacity = 100;
	this.height = 0;

	this.fileProgressWrapper = document.getElementById(this.fileProgressID);
	if (!this.fileProgressWrapper) {
		this.fileProgressWrapper = document.createElement("div");
		this.fileProgressWrapper.className = "progressWrapper";
		this.fileProgressWrapper.id = this.fileProgressID;

		this.fileProgressElement = document.createElement("div");
		this.fileProgressElement.className = "progressContainer";

		var progressCancel = document.createElement("a");
		progressCancel.className = "progressCancel";
		progressCancel.href = "#";
		progressCancel.style.visibility = "hidden";
		progressCancel.appendChild(document.createTextNode(" "));

		var progressText = document.createElement("div");
		progressText.className = "progressName";
		progressText.appendChild(document.createTextNode(file.name));

		var progressBar = document.createElement("div");
		progressBar.className = "progressBarInProgress";

		var progressStatus = document.createElement("div");
		progressStatus.className = "progressBarStatus";
		progressStatus.innerHTML = "&nbsp;";

		this.fileProgressElement.appendChild(progressCancel);
		this.fileProgressElement.appendChild(progressText);
		this.fileProgressElement.appendChild(progressStatus);
		this.fileProgressElement.appendChild(progressBar);

		this.fileProgressWrapper.appendChild(this.fileProgressElement);

		$("#album-swfu-queue").append(this.fileProgressWrapper);
	} else {
		this.fileProgressElement = this.fileProgressWrapper.firstChild;
	}

	this.height = this.fileProgressWrapper.offsetHeight;

}
FileProgress.prototype.setProgress = function (percentage) {
	this.fileProgressElement.className = "progressContainer green";
	this.fileProgressElement.childNodes[3].className = "progressBarInProgress";
	this.fileProgressElement.childNodes[3].style.width = percentage + "%";
};
FileProgress.prototype.setComplete = function () {
	this.fileProgressElement.className = "progressContainer blue";
	this.fileProgressElement.childNodes[3].className = "progressBarComplete";
	this.fileProgressElement.childNodes[3].style.width = "";

	var oSelf = this;
	setTimeout(function () {
		oSelf.disappear();
	}, 10000);
};
FileProgress.prototype.setError = function () {
	this.fileProgressElement.className = "progressContainer red";
	this.fileProgressElement.childNodes[3].className = "progressBarError";
	this.fileProgressElement.childNodes[3].style.width = "";

	var oSelf = this;
	setTimeout(function () {
		oSelf.disappear();
	}, 5000);
};
FileProgress.prototype.setCancelled = function () {
	this.fileProgressElement.className = "progressContainer";
	this.fileProgressElement.childNodes[3].className = "progressBarError";
	this.fileProgressElement.childNodes[3].style.width = "";

	var oSelf = this;
	setTimeout(function () {
		oSelf.disappear();
	}, 2000);
};
FileProgress.prototype.setStatus = function (status) {
	this.fileProgressElement.childNodes[2].innerHTML = status;
};

// Show/Hide the cancel button
FileProgress.prototype.toggleCancel = function (show, swfUploadInstance) {
	this.fileProgressElement.childNodes[0].style.visibility = show ? "visible" : "hidden";
	if (swfUploadInstance) {
		var fileID = this.fileProgressID;
		this.fileProgressElement.childNodes[0].onclick = function () {
			swfUploadInstance.cancelUpload(fileID);
			return false;
		};
	}
};

// Fades out and clips away the FileProgress box.
FileProgress.prototype.disappear = function () {

	var reduceOpacityBy = 15;
	var reduceHeightBy = 4;
	var rate = 30;	// 15 fps

	if (this.opacity > 0) {
		this.opacity -= reduceOpacityBy;
		if (this.opacity < 0) {
			this.opacity = 0;
		}

		if (this.fileProgressWrapper.filters) {
			try {
				this.fileProgressWrapper.filters.item("DXImageTransform.Microsoft.Alpha").opacity = this.opacity;
			} catch (e) {
				// If it is not set initially, the browser will throw an error.  This will set it if it is not set yet.
				this.fileProgressWrapper.style.filter = "progid:DXImageTransform.Microsoft.Alpha(opacity=" + this.opacity + ")";
			}
		} else {
			this.fileProgressWrapper.style.opacity = this.opacity / 100;
		}
	}

	if (this.height > 0) {
		this.height -= reduceHeightBy;
		if (this.height < 0) {
			this.height = 0;
		}

		this.fileProgressWrapper.style.height = this.height + "px";
	}

	if (this.height > 0 || this.opacity > 0) {
		var oSelf = this;
		setTimeout(function () {
			oSelf.disappear();
		}, rate);
	} else {
		this.fileProgressWrapper.style.display = "none";
	}
};
